﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;

namespace Win32Satellite
{
    public partial class IdentifierForm : Form
    {
        private RegistryKey key;
        private Boolean[] settingsChanged;
        private Boolean[] enabled;

		public IdentifierForm(RegistryKey regkey, Boolean[] settingsReport, Boolean[] enabledReport)
        {
            InitializeComponent();
            key = regkey;
            settingsChanged = settingsReport;
            enabled = enabledReport;
        }

        private void okClicked(object sender, EventArgs e)
        {
            if (EmailTextBox.Text.Contains("@") && !EmailTextBox.Text.Equals("user@domain.com"))
            {

                this.Hide();
                key.SetValue("identifier", IdentifierTextBox.Text);
                key.SetValue("email", EmailTextBox.Text);
                settingsChanged[0] = true;
                enabled[0] = true;
            }
            else
            {
                MessageBox.Show("Please enter a valid email address, so we can contact you if there is a problem with your satellite.");
            }
        }

        private void formLoaded(object sender, EventArgs e)
        {
            IdentifierTextBox.Text = (string)key.GetValue("identifier");
            EmailTextBox.Text = (string)key.GetValue("email");
        }
    }
}
